﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.utils.Timer;
    import flash.events.TimerEvent;
    import flash.utils.getTimer;

	public class Progresser extends Sprite
	{
		private var drawer:Sprite;
		private var data:BitmapData;
		private var background:Bitmap;
		
		//SETTINGS
		private var stepper:Number = 40;
		private var separator:Number = 100;
		private var counter:Number;
		private var line:Number;
		private var randomx:Number = Math.random()*800;
		private var colorrandom:Number = 0xff0000;
		private var sizecounter:Number = 0;
	
		
		public function Progresser()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
			var carre1Timer:Timer = new Timer(4350, 0);
        	carre1Timer.addEventListener(TimerEvent.TIMER, onCarre1Timer);
			carre1Timer.start();
			
			
		}
	
	
	
		private function onCarre1Timer(event:TimerEvent):void
{	
        colorrandom = Math.random()*0xff0000;
   // trace(colorrandom);

	
      
}
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			addEventListener(Event.ENTER_FRAME, draw);
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			removeChildAt(0);
			data = null;
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			removeChildAt(0);
			data = null;
		}
		
		private function setup():void
		{
			data = new BitmapData(stage.stageWidth,stage.stageHeight,true,0x000000);
			background = new Bitmap(data);
			addChildAt(background,0);
			drawer = new Sprite();
			counter = 0;
			line = 0;
		}
		
		private function draw(e:Event):void
		{
			if(data == null){
				setup();
			}
			counter++;
			counter++;
			counter++;
			
			drawer.graphics.clear();
			var _height:Number = mouseX;//stage.stageHeight/stepper -5;
			var _width:Number = mouseY;//stage.stageWidth/separator * counter;
			var posx:Number = mouseX;//stage.stageWidth-_width;
			var posy:Number = mouseY;//line*_height;
			
			//dessiner progressivement par ligne un rectangle avec alpha dépendant du séparator
			drawer.graphics.beginFill(colorrandom,1/separator);
			drawer.graphics.drawRect(posx,posy,_width,_height);
			drawer.graphics.endFill();
			//drawer.graphics.lineStyle(1,colorrandom,0.1);
    		//drawer.graphics.moveTo(posx,posy+300);	
    		//drawer.graphics.lineTo((600/stepper)*7,7);
    		
			
			//dessiner dans le bmpdt
			data.draw(drawer);
			
			//condition
			if(_width >= stage.stageWidth){
				counter = 0;
				line++;
			}
			if(posy>=stage.stageHeight){
				line = 100;
			}
		}
		
	}
}